function [myNmi,myAri,CUBAGE,negativeF,negativeE,CUk,c1,c2,c3,R]=CalculateCVIs(label,data,k)

%1.	Normalized mutual information (NMI)
myNmi=nmi(label,data(:,end),1);
%2.	adjusted Rand index (ARI)
myAri=adjrand(data(:,end),label);
%3.	The information entropy function (E)
negativeE=-myConditionalEntropy(data(:,1:end-1), label);
%4. proposed CUBAGE
Age=myAGE(data(:,1:end-1),label,1);
CUBAGE=myCUBAGE(Age,-negativeE);
%5. k-modes objective function (F) 
negativeF=-kmodesObjectFunction(k,label,data(:,1:end-1));
%6. category utility with 1/k (CUk) 
CUk=myCU(data(:,1:end-1),label)/k;
%7. Clope objective function (Clope) 
c1=myCLOPE(data(:,1:end-1),label,1);
c2=myCLOPE(data(:,1:end-1),label,2);
c3=myCLOPE(data(:,1:end-1),label,3);
%8. CDCS objective function (R) 
R= CDCS( data(:,1:end-1),label);
end