clear
close all
NmiFinalResults=[];
ARIFinalResults=[];

% Load datasets
% Row #1:datasets(1.voting,2.breast,3.mushroom,4.soybean,5.car,6.heart,7.dermatology,8.zoo)
titleCell={['voting'],['breast'],['mushroom'],['soybean'],['car'],['heart'],['dermatology'],['zoo']};
% Row #2:true number of classes 
% Row #3:Hierarchicies already generated.
datasets=load('datasets.mat');
datasets=datasets.datasets; 
% select dataset
for datasetNum=1:8
    % datasetNum=4;
    data=datasets{1,datasetNum};
    trueSize=datasets{2,datasetNum};
    
    % generate partitions (hierarchy) 
%         [hierarchy,mergeTrace,totalErrors]=HierarchicalAgglo(data);
    % or use the hierarchicies already generated
        hierarchy=datasets{3,datasetNum};    
    
    CVInote=[];
    % set the range of partition size
    for k=2:10
        for runsPerK=1:1
            disp(['Dataset=',titleCell{1,datasetNum},'; k=',num2str(k)])  
    %         select layer (partition)
            label=hierarchy(:,k);
    %         Calculate the values of CVIs
            [NMI,ARI,CUBAGE,negativeF,negativeE,CUk,c1,c2,c3,R]=CalculateCVIs(label,data,k);
    %         Save the CVI values 
            CVInote=[CVInote;[NMI,ARI,CUBAGE,negativeF,negativeE,CUk,c1,c2,c3,R]];
        end
    end
    NMIofCVIs=zeros(1,8);
    ARIofCVIs=zeros(1,8);
    for CVInum=1:8
        % the NMI score of the partition chosen by each internal CVI.
        NMIofCVIs(CVInum)=CVInote(CVInote(:,CVInum+2)==max(CVInote(:,CVInum+2)),1);
        % the ARI score of the partition chosen by each internal CVI.
        ARIofCVIs(CVInum)=CVInote(CVInote(:,CVInum+2)==max(CVInote(:,CVInum+2)),2);
    end
run creatFigureForHierarchy
% NMI score of each CVI on each datasets (Table6 in the paper)
NmiFinalResults=[NmiFinalResults;NMIofCVIs];
% ARI score of each CVI on each datasets (Table7 in the paper)
ARIFinalResults=[ARIFinalResults;ARIofCVIs];
end
open NmiFinalResults
open  ARIFinalResults





